#include <stdio.h>
#include <string.h>
#include "../winternitz.h"
#include "../randombytes.h"

#define MAXMLEN 100

int main(void)
{
  unsigned char sk[CRYPTO_OTS_SECRETKEYBYTES];
  unsigned char pk0[CRYPTO_OTS_PUBLICKEYBYTES];
  unsigned char pk1[CRYPTO_OTS_PUBLICKEYBYTES];
  unsigned char sig[CRYPTO_OTS_SIGBYTES];
  unsigned char m[MAXMLEN];
  unsigned long long mlen;
  unsigned int pos;

  for(mlen=0;mlen<MAXMLEN;mlen++)
  {
    randombytes(m,mlen);
    crypto_ots_keypair(pk0, sk);
    crypto_ots_sign(sig,m,mlen,sk);
    crypto_ots_verify(pk1,m,mlen,sig);
    if(memcmp(pk0,pk1,CRYPTO_OTS_PUBLICKEYBYTES))
      printf("Error: Failure verifying valid signature\n");

    /* check with modified signature */
    randombytes((unsigned char *)&pos, sizeof(int));
    pos %= CRYPTO_OTS_SIGBYTES;
    sig[pos] ^= 42;
    crypto_ots_verify(pk1,m,mlen,sig);
    if(!memcmp(pk0,pk1,CRYPTO_OTS_PUBLICKEYBYTES))
      printf("Error: Invalid signatures passes verification\n");

    sig[pos] ^= 42; /*restore original signature */
    /* check with modified message */
    if(mlen > 0)
    {
      randombytes((unsigned char *)&pos, sizeof(int));
      pos %= mlen;
      m[pos] ^= 42;
      crypto_ots_verify(pk1,m,mlen,sig);
      if(!memcmp(pk0,pk1,CRYPTO_OTS_PUBLICKEYBYTES))
        printf("Error: Invalid message passes verification\n");
    }

  }
  return 0;
}
